gnutls_prf_raw(3)

NAME
gnutls_prf_raw - access the TLS PRF directly

SYNOPSIS
#include <gnutls/gnutls.h>

int gnutls_prf_raw(gnutls_session_t session, size_t label_size, const char * label, size_t seed_size, const char * seed, size_t outsize, char * out);

ARGUMENTS

gnutls_session_t session
    is a gnutls_session_t structure.

size_t label_size
    length of the label variable.

const char * label
    label used in PRF computation, typically a short string.

size_t seed_size
    length of the seed variable.

const char * seed
    optional extra data to seed the PRF with.

size_t outsize
    size of pre-allocated output buffer to hold the output.

char * out
    pre-allocate buffer to hold the generated data.

DESCRIPTION
Apply the TLS Pseudo-Random-Function (PRF) using the master secret on some data. The label variable usually contain a string denoting the purpose for the generated data. The seed usually contain data such as the client and server random, perhaps together with some additional data that is added to guarantee uniqueness of the output for a particular purpose. Because the output is not guaranteed to be unique for a particular session unless seed include the client random and server random fields (the PRF would output the same data on another connection resumed from the first one), it is not recommended to use this function directly. The gnutls_prf() function seed the PRF with the client and server random fields directly, and is recommended if you want to generate pseudo random data unique for each session.

RETURN VALUE
Return 0 on success, or an error code.

REPORTING BUGS
Report bugs to <bug-gnutls@gnu.org>.

COPYRIGHT
Copyright © 2004 Free Software Foundation.
Permission is granted to make and distribute verbatim copies of this manual provided the copyright notice and this permission notice are preserved on all copies.

SEE ALSO
The full documentation for gnutls is maintained as a Texinfo manual. If the info and gnutls programs are properly installed at your site, the command

    info gnutls

should give you access to the complete manual.